【061-Rotate List(旋转单链表)】【LeetCode-面试算法经典-Java实现】【所有题目目录索引】原题 Given a list, rotate the list to the right by k places, where k is non-negative.
For example:
Given 1->2->3->4->5->NULL and k = 2,...
分类:
编程语言 时间:
2015-08-01 07:45:38
阅读次数:
164
Given a list, rotate the list to the right by k places, where k is non-negative.
For example:
Given 1->2->3->4->5->NULL and k = 2,
return 4->5->1->2->3->NULL.
分析:注意k有可能会大于list的长度,所以先求出list...
分类:
其他好文 时间:
2015-07-31 06:41:05
阅读次数:
119
题目Given an integer n, count the total number of digit 1 appearing in all non-negative integers less than or equal to n.For example:
Given n = 13,
Return 6, because digit 1 occurred in the following n...
分类:
其他好文 时间:
2015-07-30 13:33:17
阅读次数:
141
Description:Count the number of prime numbers less than a non-negative number,n.Hint:Let's start with aisPrimefunction. To determine if a number is pr...
分类:
其他好文 时间:
2015-07-29 00:34:37
阅读次数:
138
Problem Definition:Given n non-negative integers a1, a2, ..., an, where each represents a point at coordinate (i, ai).n vertical lines are drawn such ...
分类:
其他好文 时间:
2015-07-28 22:35:53
阅读次数:
111
Minimum Path Sum
Given a m x n grid filled with non-negative numbers, find a path from top left to bottom right which minimizes the sum of all numbers along its path.
Note: You can only move e...
分类:
其他好文 时间:
2015-07-28 18:36:31
阅读次数:
68
Description:Count the number of prime numbers less than a non-negative number,n.Credits:Special thanks to@mithmattfor adding this problem and creating...
分类:
其他好文 时间:
2015-07-27 20:53:48
阅读次数:
194
??
题目大意: 给定一个长度为n的循环序列,从n个不同位置开始,问有几个位置使得一下情况成立:所有前缀的和都大等于0(n
下午的训练赛,之前没学过单调队列所以用的线段树,一直tle,到了结束也没搞出来。晚上回来看了下,可以用单调队列来做,时间复杂度为O(n)。
这道题其实就是看从每个位置开始的最小前缀和是否大于零,但是这是有规律的。
比如从元素1(以下将元素a[i]简写为i)开始的所有...
分类:
其他好文 时间:
2015-07-27 07:10:05
阅读次数:
120
HDU 4193
题意:给n个数字组成的序列(n
思路:
这题看到数据规模觉得只能用最多O(nlogn)的算法,然后想到了之前刚做过的有关最小表示法的题,但还没证明出一个做这题有效的算法出来。
后来看过题解,发现用的最多的方法是单调队列,然而我对这个知识点知之甚少orz
/*科普君:from单调队列
单调队列是指:队列中元素之间的关系具有单调性,而且,队首和队尾都可以进行出队操作,只...
分类:
其他好文 时间:
2015-07-27 00:24:41
阅读次数:
158
题意:一个数列,求分别以每个元素为首位时(循环),前缀和都非负的序列个数
分析:
首先是个循环序列问题,所以要做处理:把序列复制一遍变成2*n的序列,这样任意一个长度为n的区间就是一种序列,共n种
然后求前缀和就可以用sum[j]-sum[i-1],这个式子表示以第i的元素为首位的序列,然后以第j个元素结尾的前缀和。同一个序列的不同结尾的前缀和每次都是减sum[i-1],只有sum[j]不同...
分类:
其他好文 时间:
2015-07-27 00:21:16
阅读次数:
106